<?php

/**
 * Payment Modul fur girosolution.de GiroConnect
 *
 * PHP version 5
 *
 * @category  Payment
 * @package   Giroconnect
 * @author    OCS
 * @copyright 2015 girosolution.de
 * @license   http://opensource.org/licenses/gpl-2.0.php GNU Public License *
 * @version   4.0.0
 * @link      http://www.girosolution.de
 * @link      http://www.gambio.de
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

// Konfiguration laden.
chdir('../../');
include_once 'includes/application_top.php';

if (file_exists(DIR_FS_CATALOG . 'includes/classes/giroconnect/library/GiroCheckout_SDK/GiroCheckout_SDK.php') === true) {
  include_once DIR_FS_CATALOG . 'includes/classes/giroconnect/library/GiroCheckout_SDK/GiroCheckout_SDK.php';
} else {
  include_once 'includes/classes/giroconnect/library/GiroCheckout_SDK/GiroCheckout_SDK.php';
}

$lang = 'de';
if (isset($_SESSION['language_code'])) {
  if (substr($_SESSION['language_code'], 0, 2) == 'en') {
    $lang = 'en';
  }
}
$paymentMsg     = '';
$paymentSuccess = false;
// Bestellnummer lesen
$data = $_GET;
$pm   = $data['pm'];

// Verbindung zur Datenbank aufbauen.
if (!xtc_db_connect()) {
  // Benachrichtigung soll nochmals erfolgen.
  header('HTTP/1.1 400 Bad Request');
  exit;
}

if (defined('MODULE_PAYMENT_' . strtoupper($pm) . '_MERCHANTID')) {
  $merchantId = constant('MODULE_PAYMENT_' . strtoupper($pm) . '_MERCHANTID');
}
if (defined('MODULE_PAYMENT_' . strtoupper($pm) . '_PROJECTID')) {
  $projectId = constant('MODULE_PAYMENT_' . strtoupper($pm) . '_PROJECTID');
}
if (defined('MODULE_PAYMENT_' . strtoupper($pm) . '_PASSWORD')) {
  $projectPassword = constant('MODULE_PAYMENT_' . strtoupper($pm) . '_PASSWORD');
}

try {
  switch ($pm) {
    case "gc_giropay":
      //Get the notification
      $notify = new GiroCheckout_SDK_Notify('giropayTransaction');
      $notify->setSecret($projectPassword);
      $notify->parseNotification($data);

      break;
    case "gc_creditcard":
      //Get the notification
      $notify = new GiroCheckout_SDK_Notify('creditCardTransaction');
      $notify->setSecret($projectPassword);
      $notify->parseNotification($data);

      break;
    case "gc_ideal":
      //Get the notification
      $notify = new GiroCheckout_SDK_Notify('idealPayment');
      $notify->setSecret($projectPassword);
      $notify->parseNotification($data);

      break;
    case "gc_eps":
      //Get the notification
      $notify = new GiroCheckout_SDK_Notify('epsTransaction');
      $notify->setSecret($projectPassword);
      $notify->parseNotification($data);

      break;
    default:
      header('HTTP/1.1 400 Bad Request');
      exit;
      break;
  }

  //check if payment was successful.
  if (!$notify->paymentSuccessful()) {
    $iReturnCode = $notify->getResponseParam('gcResultPayment');
    $newStatus = constant('MODULE_PAYMENT_' . strtoupper($pm) . '_ORDER_STATUS_ID_ERROR');
    $paymentMsg = $notify->getResponseMessage($iReturnCode, strtoupper($lang));
  } else {
    $paymentSuccess = true;
    $newStatus = constant('MODULE_PAYMENT_' . strtoupper($pm) . '_ORDER_STATUS_ID_OK');
  }
} catch (Exception $e) {
  $newStatus = constant('MODULE_PAYMENT_' . strtoupper($pm) . '_ORDER_STATUS_ID_ERROR');
  $paymentMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage(5100, strtoupper($lang));
}

// Parameter lesen.
if (!$paymentSuccess) {
  $strUrl = str_replace('&amp;', '&', xtc_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $pm . '&error=' . urlencode($paymentMsg), 'SSL'));
} else {
  $_SESSION['cart']->reset(true);
  // unregister session variables used during checkout
  unset($_SESSION['sendto']);
  unset($_SESSION['billto']);
  unset($_SESSION['shipping']);
  unset($_SESSION['payment']);
  unset($_SESSION['comments']);
  unset($_SESSION['last_order']);

  unset($_SESSION['cart_GC_ID']);
  unset($_SESSION['giroconnect']);

  //GV Code Start
  if (isset($_SESSION['credit_covers'])) {
    unset($_SESSION['credit_covers']);
  }

  $strUrl = xtc_href_link(FILENAME_CHECKOUT_SUCCESS, "order_success_text=" . urlencode($paymentMsg), 'SSL');
}

header('Location: ' . $strUrl);
exit;
