<?php

/**
 * Payment Modul fur girosolution.de.
 *
 * @version   3.0.3
 * @author    Thorsten Marx <thorsten.marx@girosolution.de>
 * @copyright 2011-2015 GiroSolution AG
 * @link      http://www.girosolution.de
 * @link      http://www.xtc-modified.org
 * @license   http://opensource.org/licenses/gpl-2.0.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */
define("__GIROCONNECT_PLUGIN_VERSION__", "3.0.3");
if (file_exists(DIR_FS_CATALOG . 'includes/classes/giroconnect/library/GiroCheckout_SDK/GiroCheckout_SDK.php')) {
  require_once DIR_FS_CATALOG . 'includes/classes/giroconnect/library/GiroCheckout_SDK/GiroCheckout_SDK.php';
} else {
  require_once '../includes/classes/giroconnect/library/GiroCheckout_SDK/GiroCheckout_SDK.php';
}

/**
 * Main class for girocheckout plugin.
 *
 * @author GiroSolution AG
 * @package GiroCheckout
 * @copyright Copyright (c) 2014, GiroSolution AG
 */
class giroconnect_main {

  var $code, $title, $description, $transaction_id, $language, $enabled, $tmpStatus;
  var $_gc_cartID = 'cart_GC_ID';

  /**
   * Constructor method.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return void
   */
  function giroconnect_main() {
    $this->transaction_id = '';
  }

// end giroconnect_main()

  /**
   * Set the language code
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return void
   */
  function _setLang() {
    if (substr($_SESSION['language_code'], 0, 2) == 'de') {
      $this->language = 'de';
    } else {
      $this->language = 'en';
    }
  }

// end _setLang()

  /**
   * Set the payment method code
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return void
   */
  function _setCode($code = 'gc_giropay') {
    $this->code = $code;
    $this->module = $code;
  }

// end _setCode()

  /**
   * Check if constant is defined.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return string
   */
  function constant($name) {
    return (defined($name)) ? constant($name) : NULL;
  }

  // end constant()

  /**
   * Javascript validation
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return boolean
   */
  function javascript_validation() {
    return false;
  }

// end javascript_validation()

  /**
   * Update the module status dynamically
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return void
   */
  function update_status() {
    global $order;

    $merchantId = trim(giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_MERCHANTID'));
    $projectId = trim(giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_PROJECTID'));
    $password = trim(giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_PASSWORD'));

    //Checks if the currency is EURO
    $currency = $_SESSION['currency'];

    if (($this->enabled == true) && ((int) giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_ZONE') > 0)) {
      $check_flag = false;
      $check_query = xtc_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . xtc_db_input(giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_ZONE')) .
              "' and zone_country_id = '" . xtc_db_input($order->billing['country']['id']) . "' order by zone_id");
      while ($check = xtc_db_fetch_array($check_query)) {
        if ($check['zone_id'] < 1) {
          $check_flag = true;
          break;
        } elseif ($check['zone_id'] == $order->billing['zone_id']) {
          $check_flag = true;
          break;
        }
      }

      if ($check_flag == false) {
        $this->enabled = false;
      }
    } else if (($this->enabled == true) && (empty($merchantId) || empty($projectId) || empty($password))) {
      $this->enabled = false;
    } else if ($this->code != "gc_creditcard" && $currency != "EUR") {
      $this->enabled = false;
    }
  }

// end update_status()

  /**
   * Displays the payment description in checkout confirmation page
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return void
   */
  function confirmation() {
    $strConfirmation = array('title' => $this->title);

    return $strConfirmation;
  }

// end confirmation()

  /**
   * Delete the order
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return void
   */
  function _deleteOrder($order_id) {
    $check_query = xtc_db_query('select orders_id from ' . TABLE_ORDERS_STATUS_HISTORY . ' where orders_id = "' . xtc_db_input((int) $order_id) . '" limit 1');
    if (xtc_db_num_rows($check_query) < 1) {
      xtc_db_query('delete from ' . TABLE_ORDERS . ' where orders_id = "' . (int) $order_id . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_TOTAL . ' where orders_id = "' . (int) $order_id . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_STATUS_HISTORY . ' where orders_id = "' . (int) $order_id . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_PRODUCTS . ' where orders_id = "' . (int) $order_id . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . ' where orders_id = "' . (int) $order_id . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_PRODUCTS_DOWNLOAD . ' where orders_id = "' . (int) $order_id . '"');
    }

    unset($_SESSION[$this->_gc_cartID]);
  }

// end _deleteOrder()

  /**
   * Functions to execute before process the payment
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return boolean
   */
  function before_process() {
    global $order;

    $insert_order = false;
    if (isset($_SESSION[$this->_gc_cartID])) {
      $parts = explode('-', $_SESSION[$this->_gc_cartID]);
      $order_id = (int) end($parts);
      $curr_check = xtc_db_query("select currency from " . TABLE_ORDERS . " where orders_id = '" . xtc_db_input($order_id) . "'");
      $curr = xtc_db_fetch_array($curr_check);
      if (($curr['currency'] != $order->info['currency']) || ($_SESSION['cart']->cartID != $parts[0])) {
        $this->_deleteOrder($order_id);
        $insert_order = true;
      }
    } else {
      $insert_order = true;
    }

    if ($insert_order == false) {
      require_once DIR_WS_CLASSES . 'order_total.php';
      $order_total_modules = new order_total();
      $order_totals = $order_total_modules->process();

      // BMC CC Mod Start
      if (strtolower(CC_ENC) == 'true') {
        $plain_data = $order->info['cc_number'];
        $order->info['cc_number'] = changedatain($plain_data, CC_KEYCHAIN);
      }
      // BMC CC Mod End

      if ($_SESSION['customers_status']['customers_status_ot_discount_flag'] == 1) {
        $discount = $_SESSION['customers_status']['customers_status_ot_discount'];
      } else {
        $discount = '0.00';
      }

      if ($_SERVER["HTTP_X_FORWARDED_FOR"]) {
        $customers_ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
      } else {
        $customers_ip = $_SERVER["REMOTE_ADDR"];
      }
      if ($_SESSION['credit_covers'] != '1') {
        $sql_data_array = array(
            'customers_id' => $_SESSION['customer_id'],
            'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
            'customers_firstname' => $order->customer['firstname'],
            'customers_lastname' => $order->customer['lastname'],
            'customers_cid' => $order->customer['csID'],
            'customers_vat_id' => $_SESSION['customer_vat_id'],
            'customers_company' => $order->customer['company'],
            'customers_status' => $_SESSION['customers_status']['customers_status_id'],
            'customers_status_name' => $_SESSION['customers_status']['customers_status_name'],
            'customers_status_image' => $_SESSION['customers_status']['customers_status_image'],
            'customers_status_discount' => $discount,
            'customers_street_address' => $order->customer['street_address'],
            'customers_suburb' => $order->customer['suburb'],
            'customers_city' => $order->customer['city'],
            'customers_postcode' => $order->customer['postcode'],
            'customers_state' => $order->customer['state'],
            'customers_country' => $order->customer['country']['title'],
            'customers_telephone' => $order->customer['telephone'],
            'customers_email_address' => $order->customer['email_address'],
            'customers_address_format_id' => $order->customer['format_id'],
            'delivery_name' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
            'delivery_firstname' => $order->delivery['firstname'],
            'delivery_lastname' => $order->delivery['lastname'],
            'delivery_company' => $order->delivery['company'],
            'delivery_street_address' => $order->delivery['street_address'],
            'delivery_suburb' => $order->delivery['suburb'],
            'delivery_city' => $order->delivery['city'],
            'delivery_postcode' => $order->delivery['postcode'],
            'delivery_state' => $order->delivery['state'],
            'delivery_country' => $order->delivery['country']['title'],
            'delivery_country_iso_code_2' => $order->delivery['country']['iso_code_2'],
            'delivery_address_format_id' => $order->delivery['format_id'],
            'billing_name' => $order->billing['firstname'] . ' ' . $order->billing['lastname'],
            'billing_firstname' => $order->billing['firstname'],
            'billing_lastname' => $order->billing['lastname'],
            'billing_company' => $order->billing['company'],
            'billing_street_address' => $order->billing['street_address'],
            'billing_suburb' => $order->billing['suburb'],
            'billing_city' => $order->billing['city'],
            'billing_postcode' => $order->billing['postcode'],
            'billing_state' => $order->billing['state'],
            'billing_country' => $order->billing['country']['title'],
            'billing_country_iso_code_2' => $order->billing['country']['iso_code_2'],
            'billing_address_format_id' => $order->billing['format_id'],
            'payment_method' => $order->info['payment_method'],
            'payment_class' => $order->info['payment_class'],
            'shipping_method' => $order->info['shipping_method'],
            'shipping_class' => $order->info['shipping_class'],
            'cc_type' => $order->info['cc_type'],
            'cc_owner' => $order->info['cc_owner'],
            'cc_number' => $order->info['cc_number'],
            'cc_expires' => $order->info['cc_expires'],
            'cc_start' => $order->info['cc_start'],
            'cc_cvv' => $order->info['cc_cvv'],
            'cc_issue' => $order->info['cc_issue'],
            'date_purchased' => 'now()',
            'orders_status' => $this->tmpStatus,
            'currency' => $order->info['currency'],
            'currency_value' => $order->info['currency_value'],
            'customers_ip' => $customers_ip,
            'language' => $_SESSION['language'],
            'comments' => $order->info['comments']
        );
      } else {
        // free gift , no paymentaddress
        $sql_data_array = array(
            'customers_id' => $_SESSION['customer_id'],
            'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
            'customers_firstname' => $order->customer['firstname'],
            'customers_lastname' => $order->customer['lastname'],
            'customers_cid' => $order->customer['csID'],
            'customers_vat_id' => $_SESSION['customer_vat_id'],
            'customers_company' => $order->customer['company'],
            'customers_status' => $_SESSION['customers_status']['customers_status_id'],
            'customers_status_name' => $_SESSION['customers_status']['customers_status_name'],
            'customers_status_image' => $_SESSION['customers_status']['customers_status_image'],
            'customers_status_discount' => $discount,
            'customers_street_address' => $order->customer['street_address'],
            'customers_suburb' => $order->customer['suburb'],
            'customers_city' => $order->customer['city'],
            'customers_postcode' => $order->customer['postcode'],
            'customers_state' => $order->customer['state'],
            'customers_country' => $order->customer['country']['title'],
            'customers_telephone' => $order->customer['telephone'],
            'customers_email_address' => $order->customer['email_address'],
            'customers_address_format_id' => $order->customer['format_id'],
            'delivery_name' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
            'delivery_firstname' => $order->delivery['firstname'],
            'delivery_lastname' => $order->delivery['lastname'],
            'delivery_company' => $order->delivery['company'],
            'delivery_street_address' => $order->delivery['street_address'],
            'delivery_suburb' => $order->delivery['suburb'],
            'delivery_city' => $order->delivery['city'],
            'delivery_postcode' => $order->delivery['postcode'],
            'delivery_state' => $order->delivery['state'],
            'delivery_country' => $order->delivery['country']['title'],
            'delivery_country_iso_code_2' => $order->delivery['country']['iso_code_2'],
            'delivery_address_format_id' => $order->delivery['format_id'],
            'payment_method' => $order->info['payment_method'],
            'payment_class' => $order->info['payment_class'],
            'shipping_method' => $order->info['shipping_method'],
            'shipping_class' => $order->info['shipping_class'],
            'cc_type' => $order->info['cc_type'],
            'cc_owner' => $order->info['cc_owner'],
            'cc_number' => $order->info['cc_number'],
            'cc_expires' => $order->info['cc_expires'],
            'date_purchased' => 'now()',
            'orders_status' => $this->tmpStatus,
            'currency' => $order->info['currency'],
            'currency_value' => $order->info['currency_value'],
            'customers_ip' => $customers_ip,
            'comments' => $order->info['comments']
        );
      }

      xtc_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = "' . (int) $order_id . '"');

      //add order comment of customer to order history
      if(!empty($order->info['comments'])) {
        $customer_notification = '0';
        $sql_data_array = array(
            'orders_id' => $order_id,
            'orders_status_id' => $this->tmpStatus,
            'date_added' => 'now()',
            'customer_notified' => $customer_notification,
            'comments' => $order->info['comments']
        );
        xtc_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
      }

      $_SESSION['tmp_oID'] = $order_id;
      xtc_db_query('delete from ' . TABLE_ORDERS_TOTAL . ' where orders_id = "' . xtc_db_input((int) $order_id) . '"');
      for ($i = 0, $n = sizeof($order_totals); $i < $n; $i++) {
        $sql_data_array = array(
            'orders_id' => $order_id,
            'title' => $order_totals[$i]['title'],
            'text' => $order_totals[$i]['text'],
            'value' => $order_totals[$i]['value'],
            'class' => $order_totals[$i]['code'],
            'sort_order' => $order_totals[$i]['sort_order']
        );
        xtc_db_perform(TABLE_ORDERS_TOTAL, $sql_data_array);
      }

      if (isset($_SESSION['tracking']['refID'])) {

        xtc_db_query("update " . TABLE_ORDERS . " set refferers_id = '" . xtc_db_input($_SESSION['tracking']['refID']) . "' where orders_id = '" . xtc_db_input($order_id) . "'");
        // check if late or direct sale
        $customers_logon_query = "SELECT customers_info_number_of_logons FROM " . TABLE_CUSTOMERS_INFO . " WHERE customers_info_id  = '" . xtc_db_input($_SESSION['customer_id']) . "'";
        $customers_logon_query = xtc_db_query($customers_logon_query);
        $customers_logon = xtc_db_fetch_array($customers_logon_query);

        if ($customers_logon['customers_info_number_of_logons'] == 0) {
          // direct sale
          xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '1' where orders_id = '" . xtc_db_input($insert_id) . "'");
        } else {
          // late sale
          xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '2' where orders_id = '" . xtc_db_input($insert_id) . "'");
        }
      } else {

        $customers_query = xtc_db_query("SELECT refferers_id as ref FROM " . TABLE_CUSTOMERS . " WHERE customers_id='" . xtc_db_input($_SESSION['customer_id']) . "'");
        $customers_data = xtc_db_fetch_array($customers_query);
        if (xtc_db_num_rows($customers_query)) {

          xtc_db_query("update " . TABLE_ORDERS . " set refferers_id = '" . $customers_data['ref'] . "' where orders_id = '" . xtc_db_input($order_id) . "'");
          // check if late or direct sale
          $customers_logon_query = "SELECT customers_info_number_of_logons FROM " . TABLE_CUSTOMERS_INFO . " WHERE customers_info_id  = '" . xtc_db_input($_SESSION['customer_id']) . "'";
          $customers_logon_query = xtc_db_query($customers_logon_query);
          $customers_logon = xtc_db_fetch_array($customers_logon_query);

          if ($customers_logon['customers_info_number_of_logons'] == 0) {
            // direct sale
            xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '1' where orders_id = '" . xtc_db_input($insert_id) . "'");
          } else {
            // late sale
            xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '2' where orders_id = '" . xtc_db_input($insert_id) . "'");
          }
        }
      }
    }

    if ($insert_order == true) {

      require_once DIR_WS_CLASSES . 'order_total.php';
      $order_total_modules = new order_total();
      $order_totals = $order_total_modules->process();

      // BMC CC Mod Start
      if (strtolower(CC_ENC) == 'true') {
        $plain_data = $order->info['cc_number'];
        $order->info['cc_number'] = changedatain($plain_data, CC_KEYCHAIN);
      }
      // BMC CC Mod End

      if ($_SESSION['customers_status']['customers_status_ot_discount_flag'] == 1) {
        $discount = $_SESSION['customers_status']['customers_status_ot_discount'];
      } else {
        $discount = '0.00';
      }

      if ($_SERVER["HTTP_X_FORWARDED_FOR"]) {
        $customers_ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
      } else {
        $customers_ip = $_SERVER["REMOTE_ADDR"];
      }

      if ($_SESSION['credit_covers'] != '1') {
        $sql_data_array = array(
            'customers_id' => $_SESSION['customer_id'],
            'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
            'customers_firstname' => $order->customer['firstname'],
            'customers_lastname' => $order->customer['lastname'],
            'customers_cid' => $order->customer['csID'],
            'customers_vat_id' => $_SESSION['customer_vat_id'],
            'customers_company' => $order->customer['company'],
            'customers_status' => $_SESSION['customers_status']['customers_status_id'],
            'customers_status_name' => $_SESSION['customers_status']['customers_status_name'],
            'customers_status_image' => $_SESSION['customers_status']['customers_status_image'],
            'customers_status_discount' => $discount,
            'customers_street_address' => $order->customer['street_address'],
            'customers_suburb' => $order->customer['suburb'],
            'customers_city' => $order->customer['city'],
            'customers_postcode' => $order->customer['postcode'],
            'customers_state' => $order->customer['state'],
            'customers_country' => $order->customer['country']['title'],
            'customers_telephone' => $order->customer['telephone'],
            'customers_email_address' => $order->customer['email_address'],
            'customers_address_format_id' => $order->customer['format_id'],
            'delivery_name' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
            'delivery_firstname' => $order->delivery['firstname'],
            'delivery_lastname' => $order->delivery['lastname'],
            'delivery_company' => $order->delivery['company'],
            'delivery_street_address' => $order->delivery['street_address'],
            'delivery_suburb' => $order->delivery['suburb'],
            'delivery_city' => $order->delivery['city'],
            'delivery_postcode' => $order->delivery['postcode'],
            'delivery_state' => $order->delivery['state'],
            'delivery_country' => $order->delivery['country']['title'],
            'delivery_country_iso_code_2' => $order->delivery['country']['iso_code_2'],
            'delivery_address_format_id' => $order->delivery['format_id'],
            'billing_name' => $order->billing['firstname'] . ' ' . $order->billing['lastname'],
            'billing_firstname' => $order->billing['firstname'],
            'billing_lastname' => $order->billing['lastname'],
            'billing_company' => $order->billing['company'],
            'billing_street_address' => $order->billing['street_address'],
            'billing_suburb' => $order->billing['suburb'],
            'billing_city' => $order->billing['city'],
            'billing_postcode' => $order->billing['postcode'],
            'billing_state' => $order->billing['state'],
            'billing_country' => $order->billing['country']['title'],
            'billing_country_iso_code_2' => $order->billing['country']['iso_code_2'],
            'billing_address_format_id' => $order->billing['format_id'],
            'payment_method' => $order->info['payment_method'],
            'payment_class' => $order->info['payment_class'],
            'shipping_method' => $order->info['shipping_method'],
            'shipping_class' => $order->info['shipping_class'],
            'cc_type' => $order->info['cc_type'],
            'cc_owner' => $order->info['cc_owner'],
            'cc_number' => $order->info['cc_number'],
            'cc_expires' => $order->info['cc_expires'],
            'cc_start' => $order->info['cc_start'],
            'cc_cvv' => $order->info['cc_cvv'],
            'cc_issue' => $order->info['cc_issue'],
            'date_purchased' => 'now()',
            'orders_status' => $this->tmpStatus,
            'currency' => $order->info['currency'],
            'currency_value' => $order->info['currency_value'],
            'customers_ip' => $customers_ip,
            'language' => $_SESSION['language'],
            'comments' => $order->info['comments']
        );
      } else {
        // free gift , no paymentaddress
        $sql_data_array = array(
            'customers_id' => $_SESSION['customer_id'],
            'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
            'customers_firstname' => $order->customer['firstname'],
            'customers_lastname' => $order->customer['lastname'],
            'customers_cid' => $order->customer['csID'],
            'customers_vat_id' => $_SESSION['customer_vat_id'],
            'customers_company' => $order->customer['company'],
            'customers_status' => $_SESSION['customers_status']['customers_status_id'],
            'customers_status_name' => $_SESSION['customers_status']['customers_status_name'],
            'customers_status_image' => $_SESSION['customers_status']['customers_status_image'],
            'customers_status_discount' => $discount,
            'customers_street_address' => $order->customer['street_address'],
            'customers_suburb' => $order->customer['suburb'],
            'customers_city' => $order->customer['city'],
            'customers_postcode' => $order->customer['postcode'],
            'customers_state' => $order->customer['state'],
            'customers_country' => $order->customer['country']['title'],
            'customers_telephone' => $order->customer['telephone'],
            'customers_email_address' => $order->customer['email_address'],
            'customers_address_format_id' => $order->customer['format_id'],
            'delivery_name' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
            'delivery_firstname' => $order->delivery['firstname'],
            'delivery_lastname' => $order->delivery['lastname'],
            'delivery_company' => $order->delivery['company'],
            'delivery_street_address' => $order->delivery['street_address'],
            'delivery_suburb' => $order->delivery['suburb'],
            'delivery_city' => $order->delivery['city'],
            'delivery_postcode' => $order->delivery['postcode'],
            'delivery_state' => $order->delivery['state'],
            'delivery_country' => $order->delivery['country']['title'],
            'delivery_country_iso_code_2' => $order->delivery['country']['iso_code_2'],
            'delivery_address_format_id' => $order->delivery['format_id'],
            'payment_method' => $order->info['payment_method'],
            'payment_class' => $order->info['payment_class'],
            'shipping_method' => $order->info['shipping_method'],
            'shipping_class' => $order->info['shipping_class'],
            'cc_type' => $order->info['cc_type'],
            'cc_owner' => $order->info['cc_owner'],
            'cc_number' => $order->info['cc_number'],
            'cc_expires' => $order->info['cc_expires'],
            'date_purchased' => 'now()',
            'orders_status' => $this->tmpStatus,
            'currency' => $order->info['currency'],
            'currency_value' => $order->info['currency_value'],
            'customers_ip' => $customers_ip,
            'comments' => $order->info['comments']
        );
      }

      xtc_db_perform(TABLE_ORDERS, $sql_data_array);
      $insert_id = xtc_db_insert_id();
      $_SESSION['tmp_oID'] = $insert_id;
      for ($i = 0, $n = sizeof($order_totals); $i < $n; $i++) {
        $sql_data_array = array(
            'orders_id' => $insert_id,
            'title' => $order_totals[$i]['title'],
            'text' => $order_totals[$i]['text'],
            'value' => $order_totals[$i]['value'],
            'class' => $order_totals[$i]['code'],
            'sort_order' => $order_totals[$i]['sort_order']
        );
        xtc_db_perform(TABLE_ORDERS_TOTAL, $sql_data_array);
      }

      //add order comment of customer to order history
      if(!empty($order->info['comments'])) {
        $customer_notification = '0';
        $sql_data_array = array(
          'orders_id' => $insert_id,
          'orders_status_id' => $this->tmpStatus,
          'date_added' => 'now()',
          'customer_notified' => $customer_notification,
          'comments' => $order->info['comments']
        );
        xtc_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
      }
      // initialized for the email confirmation
      $products_ordered = '';
      $products_ordered_html = '';
      $subtotal = 0;
      $total_tax = 0;

      for ($i = 0, $n = sizeof($order->products); $i < $n; $i++) {
        // Stock Update - Joao Correia
        if (STOCK_LIMITED == 'true') {
          if (DOWNLOAD_ENABLED == 'true') {
            $stock_query_raw = "SELECT products_quantity, pad.products_attributes_filename
                                  FROM " . TABLE_PRODUCTS . " p
                                  LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                   ON p.products_id=pa.products_id
                                  LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                   ON pa.products_attributes_id=pad.products_attributes_id
                                  WHERE p.products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'";
            // Will work with only one option for downloadable products
            // otherwise, we have to build the query dynamically with a loop
            $products_attributes = $order->products[$i]['attributes'];
            if (is_array($products_attributes)) {
              $stock_query_raw .= " AND pa.options_id = '" . xtc_db_input($products_attributes[0]['option_id']) . "' AND pa.options_values_id = '" . xtc_db_input($products_attributes[0]['value_id']) . "'";
            }
            $stock_query = xtc_db_query($stock_query_raw);
          } else {
            $stock_query = xtc_db_query("
              select products_quantity
              from " . TABLE_PRODUCTS . "
              where products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'");
          }
          if (xtc_db_num_rows($stock_query) > 0) {
            $stock_values = xtc_db_fetch_array($stock_query);
            // do not decrement quantities if products_attributes_filename exists
            if ((DOWNLOAD_ENABLED != 'true') || (!$stock_values['products_attributes_filename'])) {
              $stock_left = $stock_values['products_quantity'] - $order->products[$i]['qty'];
            } else {
              $stock_left = $stock_values['products_quantity'];
            }

            xtc_db_query("update " . TABLE_PRODUCTS . " set products_quantity = '" . xtc_db_input($stock_left) . "' where products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'");
            if (($stock_left < 1) && (STOCK_ALLOW_CHECKOUT == 'false')) {
              xtc_db_query("update " . TABLE_PRODUCTS . " set products_status = '0' where products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'");
            }
          }
        }

        // Update products_ordered (for bestsellers list)
        xtc_db_query("update " . TABLE_PRODUCTS . " set products_ordered = products_ordered + " . xtc_db_input(sprintf('%d', $order->products[$i]['qty'])) . " where products_id = '" .
                xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'");

        $sql_data_array = array(
            'orders_id' => $insert_id,
            'products_id' => xtc_get_prid($order->products[$i]['id']),
            'products_model' => $order->products[$i]['model'],
            'products_name' => $order->products[$i]['name'],
            'products_shipping_time' => $order->products[$i]['shipping_time'],
            'products_price' => $order->products[$i]['price'],
            'final_price' => $order->products[$i]['final_price'],
            'products_tax' => $order->products[$i]['tax'],
            'products_discount_made' => $order->products[$i]['discount_allowed'],
            'products_quantity' => $order->products[$i]['qty'],
            'allow_tax' => $_SESSION['customers_status']['customers_status_show_price_tax']
        );

        xtc_db_perform(TABLE_ORDERS_PRODUCTS, $sql_data_array);
        $order_products_id = xtc_db_insert_id();

        // Aenderung Specials Quantity Anfang
        $specials_result = xtc_db_query("SELECT products_id, specials_quantity from " . TABLE_SPECIALS . " WHERE products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) .
                "' ");
        if (xtc_db_num_rows($specials_result)) {
          $spq = xtc_db_fetch_array($specials_result);

          $new_sp_quantity = ($spq['specials_quantity'] - $order->products[$i]['qty']);

          if ($new_sp_quantity >= 1) {
            xtc_db_query("update " . TABLE_SPECIALS . " set specials_quantity = '" . xtc_db_input($new_sp_quantity) . "' where products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "' ");
          } else {
            xtc_db_query("update " . TABLE_SPECIALS . " set status = '0', specials_quantity = '" . xtc_db_input($new_sp_quantity) . "' where products_id = '" .
                    xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "' ");
          }
        }
        // Aenderung Ende

        $order_total_modules->update_credit_account($i); // GV Code ICW ADDED FOR CREDIT CLASS SYSTEM
        //------insert customer choosen option to order--------
        $attributes_exist = '0';
        $products_ordered_attributes = '';
        if (isset($order->products[$i]['attributes'])) {
          $attributes_exist = '1';
          for ($j = 0, $n2 = sizeof($order->products[$i]['attributes']); $j < $n2; $j++) {
            if (DOWNLOAD_ENABLED == 'true') {
              $attributes_query = "select popt.products_options_name,
                                     poval.products_options_values_name,
                                     pa.options_values_price,
                                     pa.price_prefix,
                                     pad.products_attributes_maxdays,
                                     pad.products_attributes_maxcount,
                                     pad.products_attributes_filename
                                   from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                   left join " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                     on pa.products_attributes_id=pad.products_attributes_id
                                   where pa.products_id = '" . xtc_db_input($order->products[$i]['id']) . "'
                                     and pa.options_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['option_id']) . "'
                                     and pa.options_id = popt.products_options_id
                                     and pa.options_values_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['value_id']) . "'
                                     and pa.options_values_id = poval.products_options_values_id
                                     and popt.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'
                                     and poval.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'";

              $attributes = xtc_db_query($attributes_query);
            } else {
              $attributes = xtc_db_query("select popt.products_options_name,
                                            poval.products_options_values_name,
                                            pa.options_values_price,
                                            pa.price_prefix
                                          from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                          where pa.products_id = '" . xtc_db_input($order->products[$i]['id']) . "'
                                            and pa.options_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['option_id']) . "'
                                            and pa.options_id = popt.products_options_id
                                            and pa.options_values_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['value_id']) . "'
                                            and pa.options_values_id = poval.products_options_values_id
                                            and popt.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'
                                            and poval.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'");
            }

            // update attribute stock
            xtc_db_query("UPDATE " . TABLE_PRODUCTS_ATTRIBUTES . " set
                            attributes_stock=attributes_stock - '" . xtc_db_input($order->products[$i]['qty']) . "'
                          where
                            products_id='" . xtc_db_input($order->products[$i]['id']) . "'
                            and options_values_id='" . xtc_db_input($order->products[$i]['attributes'][$j]['value_id']) . "'
                            and options_id='" . xtc_db_input($order->products[$i]['attributes'][$j]['option_id']) . "'");

            $attributes_values = xtc_db_fetch_array($attributes);

            $sql_data_array = array(
                'orders_id' => $insert_id,
                'orders_products_id' => $order_products_id,
                'products_options' => $attributes_values['products_options_name'],
                'products_options_values' => $attributes_values['products_options_values_name'],
                'options_values_price' => $attributes_values['options_values_price'],
                'price_prefix' => $attributes_values['price_prefix']
            );
            xtc_db_perform(TABLE_ORDERS_PRODUCTS_ATTRIBUTES, $sql_data_array);

            if ((DOWNLOAD_ENABLED == 'true') && isset($attributes_values['products_attributes_filename']) && xtc_not_null($attributes_values['products_attributes_filename'])) {
              $sql_data_array = array(
                  'orders_id' => $insert_id,
                  'orders_products_id' => $order_products_id,
                  'orders_products_filename' => $attributes_values['products_attributes_filename'],
                  'download_maxdays' => $attributes_values['products_attributes_maxdays'],
                  'download_count' => $attributes_values['products_attributes_maxcount']
              );
              xtc_db_perform(TABLE_ORDERS_PRODUCTS_DOWNLOAD, $sql_data_array);
            }
          }
        }
        //------insert customer choosen option eof ----
        $total_weight += ($order->products[$i]['qty'] * $order->products[$i]['weight']);
        $total_tax += xtc_calculate_tax($total_products_price, $products_tax) * $order->products[$i]['qty'];
        $total_cost += $total_products_price;
      }

      if (isset($_SESSION['tracking']['refID'])) {

        xtc_db_query("update " . TABLE_ORDERS . " set refferers_id = '" . xtc_db_input($_SESSION['tracking']['refID']) . "' where orders_id = '" . xtc_db_input($insert_id) . "'");
        // check if late or direct sale
        $customers_logon_query = "SELECT customers_info_number_of_logons FROM " . TABLE_CUSTOMERS_INFO . " WHERE customers_info_id  = '" . xtc_db_input($_SESSION['customer_id']) . "'";
        $customers_logon_query = xtc_db_query($customers_logon_query);
        $customers_logon = xtc_db_fetch_array($customers_logon_query);

        if ($customers_logon['customers_info_number_of_logons'] == 0) {
          // direct sale
          xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '1' where orders_id = '" . xtc_db_input($insert_id) . "'");
        } else {
          // late sale
          xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '2' where orders_id = '" . xtc_db_input($insert_id) . "'");
        }
      } else {

        $customers_query = xtc_db_query("SELECT refferers_id as ref FROM " . TABLE_CUSTOMERS . " WHERE customers_id='" . xtc_db_input($_SESSION['customer_id']) . "'");
        $customers_data = xtc_db_fetch_array($customers_query);
        if (xtc_db_num_rows($customers_query)) {

          xtc_db_query("update " . TABLE_ORDERS . " set refferers_id = '" . $customers_data['ref'] . "' where orders_id = '" . xtc_db_input($insert_id) . "'");
          // check if late or direct sale
          $customers_logon_query = "SELECT customers_info_number_of_logons FROM " . TABLE_CUSTOMERS_INFO . " WHERE customers_info_id  = '" . xtc_db_input($_SESSION['customer_id']) . "'";
          $customers_logon_query = xtc_db_query($customers_logon_query);
          $customers_logon = xtc_db_fetch_array($customers_logon_query);

          if ($customers_logon['customers_info_number_of_logons'] == 0) {
            // direct sale
            xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '1' where orders_id = '" . xtc_db_input($insert_id) . "'");
          } else {
            // late sale
            xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '2' where orders_id = '" . xtc_db_input($insert_id) . "'");
          }
        }
      }

      $_SESSION[$this->_gc_cartID] = $_SESSION['cartID'] . '-' . $insert_id;
    }

    $this->payment_action();

    return false;
  }

// end before_process()

  /**
   * Functions to execute after process the payment
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return boolean
   */
  function after_process() {
    return false;
  }

//end after_process()

  /**
   * Get error message to display
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return array
   */
  function get_error() {
    global $_GET;
    $error = array(
        'title' => $this->title,
        'error' => utf8_decode(stripslashes(urldecode($_GET['error'])))
    );

    return $error;
  }

//end get_error()

  /**
   * Check if module is installed (Administration Tool)_
   * TABLES: configuration
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return int
   */
  function check() {
    if (!isset($this->_check)) {
      $check_query = xtc_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_STATUS'");
      $this->_check = xtc_db_num_rows($check_query);
    }

    return $this->_check;
  }

  /**
   * Install the module (Administration Tool)_
   * TABLES: configuration
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return void
   */
  function install() {
    // Update Configuration Key Length 64 is often too short
    xtc_db_query('ALTER TABLE ' . TABLE_CONFIGURATION . ' CHANGE configuration_key configuration_key VARCHAR( 255 ) NOT NULL');
    // Update Configuration field Length 255 is often too short
    //xtc_db_query('ALTER TABLE ' . TABLE_CONFIGURATION . ' CHANGE set_function set_function VARCHAR( 510 ) NOT NULL');

    $cancelled_status_id = '2';
    $check_query = xtc_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Canceled [Giroconnect]' limit 1");
    if (xtc_db_num_rows($check_query) < 1) {
      $status_query = xtc_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
      $status = xtc_db_fetch_array($status_query);
      $cancelled_status_id = $status['status_id'] + 1;
      $languages = xtc_get_languages();
      foreach ($languages as $lang) {
        xtc_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . xtc_db_input($cancelled_status_id) . "', '" . xtc_db_input($lang['id']) . "', 'Canceled [Giroconnect]')");
      }
    } else {
      $check = xtc_db_fetch_array($check_query);
      $cancelled_status_id = $check['orders_status_id'];
    }

    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_STATUS', 'True', '6', '0', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_SORT_ORDER', '0', '6', '0', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_MERCHANTID', '', '6', '10', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_PROJECTID', '', '6', '10', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_PASSWORD', '', '6', '10', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_ZONE', '0', '6', '20', 'xtc_get_zone_class_title', 'xtc_cfg_pull_down_zone_classes(', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_ALLOWED', 'DE', '6', '30', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_ORDER_STATUS_ID_ERROR', '" . xtc_db_input($cancelled_status_id) . "', '6', '40', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_ORDER_STATUS_ID_OK', '1', '6', '40', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_ORDER_STATUS_ID_TEMP', '2', '6', '40', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added)" .
            "  values ('MODULE_PAYMENT_" . strtoupper($this->code) . "_DELETE_ORDER', 'True', '6', '0', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");

    //create table to register orders and status.
    xtc_db_query("CREATE TABLE IF NOT EXISTS gc_transactions(
                  tx_id int(11) NOT NULL AUTO_INCREMENT,
                  order_id int(11) NOT NULL,
                  rc int(11) NULL,
                  rc_msg varchar(255) NULL,
                  init_start int(11) NULL,
                  init_end int(11) NULL,
                  time_finished int(11) NULL,
                  reference varchar(255) NULL,
                  backend_tx_id varchar(255) NULL,
                  result_payment int(11) NULL,
                  result_payment_msg varchar(255) NULL,
                  tx_status int(1) NOT NULL,
                  payment_code varchar(100) NULL,
                  comment text NULL,
                  PRIMARY KEY (tx_id)
                  )");

    $columns_query = xtc_db_query("SHOW COLUMNS FROM `gc_transactions` LIKE '%payment_code%'");
    if (!xtc_db_num_rows($columns_query)) {
      xtc_db_query("ALTER TABLE `gc_transactions` ADD `payment_code` varchar(100) NULL");
    }

    $columns_query = xtc_db_query("SHOW COLUMNS FROM `gc_transactions` LIKE '%comment%'");
    if (!xtc_db_num_rows($columns_query)) {
      xtc_db_query("ALTER TABLE `gc_transactions` ADD `comment` text NULL");
    }
  }

// end install()

  /**
   * Remove the module (Administration Tool)_
   * TABLES: configuration
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return void
   */
  function remove() {
    $strKeys = implode("', '", $this->keys());
    xtc_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . $strKeys . "')");
  }

  //end remove()

  /**
   * Retrieve the modules configuration keys (Administration Tool)_
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return array
   */
  function keys() {
    $keys = array("MODULE_PAYMENT_" . strtoupper($this->code) . "_STATUS");
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_SORT_ORDER";
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_MERCHANTID";
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_PROJECTID";
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_PASSWORD";
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_ZONE";
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_ALLOWED";
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_DELETE_ORDER";
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_ORDER_STATUS_ID_ERROR";
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_ORDER_STATUS_ID_OK";
    $keys[] = "MODULE_PAYMENT_" . strtoupper($this->code) . "_ORDER_STATUS_ID_TEMP";
    return $keys;
  }

// end keys()

  /**
   * Returns plugin and shop version.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return string
   */
  public function getGcSource() {
    return PROJECT_VERSION . ";xtCommerce 3 Plugin " . __GIROCONNECT_PLUGIN_VERSION__;
  }

}

// end class giroconnect_main
