<?php

/**
 * GiroCheckout SDK.
 *
 * Include just this file. It will load any required files to use the SDK.
 * View examples for API calls.
 *
 * @package GiroCheckout
 * @version $Revision: 103 $ / $Date: 2015-03-25 15:29:01 +0100 (Mi, 25 Mrz 2015) $
 */
define('__GIROCHECKOUT_SDK_VERSION__', '1.5.5');

if (defined('__GIROCHECKOUT_SDK_DEBUG__') && GIROCHECKOUT_SDK_DEBUG) {
  if (defined('DIR_FS_CATALOG')) {
    if (file_exists(DIR_FS_CATALOG . 'log')) {
      define('__GIROCHECKOUT_SDK_DEBUG_LOG_PATH__', DIR_FS_CATALOG . 'log/');
    } else if (file_exists(DIR_FS_CATALOG . 'logfiles')) {
      define('__GIROCHECKOUT_SDK_DEBUG_LOG_PATH__', DIR_FS_CATALOG . 'logfiles/');
    } else {
      define('__GIROCHECKOUT_SDK_DEBUG_LOG_PATH__', dirname(__FILE__) . '/log/');
    }
  } else {
    if (file_exists('../../../../../log')) {
      define('__GIROCHECKOUT_SDK_DEBUG_LOG_PATH__', '../../../../../log/');
    } else if (file_exists(DIR_FS_CATALOG . 'logfiles')) {
      define('__GIROCHECKOUT_SDK_DEBUG_LOG_PATH__', '../../../../../logfiles/');
    } else {
      define('__GIROCHECKOUT_SDK_DEBUG_LOG_PATH__', dirname(__FILE__) . '/log/');
    }
  }
} else {
  define('__GIROCHECKOUT_SDK_DEBUG__', false);

  class GiroCheckout_SDK_Autoloader {

    public static function load($classname) {
      $filename = $classname . '.php';

      $pathsArray = array('api',
          'helper',
          './',
          'api/giropay',
          'api/directdebit',
          'api/creditcard',
          'api/eps',
          'api/ideal',
          'api/paypal',
          'api/tools',
          'api/girocode'
      );

      foreach ($pathsArray as $path) {
        if ($path == './') {
          $pathToFile = dirname(__FILE__) . DIRECTORY_SEPARATOR . $filename;
        } else {
          $pathToFile = dirname(__FILE__) . DIRECTORY_SEPARATOR . $path . DIRECTORY_SEPARATOR . $filename;
        }

        if (file_exists($pathToFile)) {
          require_once $pathToFile;
          return true;
        } else {
          continue;
        }
      }
      return false;
    }

  }

}
spl_autoload_register(array('GiroCheckout_SDK_Autoloader', 'load'));
